#include "qt4urpmi.h"
#include "ui_qt4urpmi.h"
#include <iostream>
#include <QtCore>
#include <QtGui>
#include <QAction>

using namespace std;


qt4urpmi::qt4urpmi(QWidget *parent)
    : QMainWindow(parent), ui(new Ui::qt4urpmi)
{
    uid = getuid();
    if (uid != 0 )
    {
        QMessageBox msgBox;
        msgBox.setText("You need to be root!");
        msgBox.exec();
        delete ui;
    }
    ui->setupUi(this);
    createActions();
    ui->t_results->setColumnWidth(0,517);
    connect(ui->b_search,SIGNAL(clicked()),this,SLOT(startseach()));
    connect(&proc,SIGNAL(readyReadStandardOutput()), this,SLOT(ready()));
    connect(&proc,SIGNAL(finished(int , QProcess::ExitStatus )),this,SLOT(finish()));
    connect(ui->t_results,SIGNAL(cellPressed(int,int)), this, SLOT(mark(int,int)));
}

qt4urpmi::~qt4urpmi()
{
    delete ui;
}


void qt4urpmi::startseach()
{
    //searchstring = ui->e_search->text();
    QString command("urpmq --auto-orphans");
    //command+=searchstring;
    //if (ui->e_search->text() != "") {
     //   command+=" | grep ";
     //   command+=searchstring;
    //}
    cout << command.toStdString() << "\n";
    QString result;
    //ui->t_results->setRowCount(199);
     i = 0;
    proc.start(command);

}

void qt4urpmi::ready()
{

    cout << "Läuft ..." << "\n";
    while (proc.canReadLine()) {
        ui->l_status->setText("searching ...");
        ui->t_results->setRowCount(i+1);
        but1 = new QPushButton("Click",this);
        ui->t_results->setItem(i,0,new QTableWidgetItem(QString(proc.readLine())));
        //ui->t_results->setCellWidget(i,1,new QPushButton("...",this));
        i++;
    }

}

void qt4urpmi::finish()
{
    //ui->t_results->setRowCount(i);
    ui->l_status->setText("Process finished");
    proc.close();
}

void qt4urpmi::mark(int r, int c)
{
    //string paket = ui->t_results->item(r,c);

    reihe = r;
    spalte = c;
    cout << "Reihe: " << reihe << '\n';
    cout << spalte << '\n';

}

void qt4urpmi::install()
{
    QString wert("/usr/sbin/urpmi ");
    wert+=ui->t_results->item(reihe,spalte)->data(Qt::DisplayRole).toString();
    cout << "Wert ist: "<< wert.toStdString() << "\n";
    QProcess install;
    //install.start(wert);
    string str = wert.toStdString();
    system(str.c_str());
    qt4urpmi::startseach();
}

void qt4urpmi::remove()
{
    QString strRemove("/usr/sbin/urpme ");
    strRemove+=ui->t_results->item(reihe,spalte)->data(Qt::DisplayRole).toString();
    string str2 = strRemove.toStdString();
    system(str2.c_str());
    cout << "Remove: " << reihe << "\n";
    qt4urpmi::startseach();
}

void qt4urpmi::createActions()
{
    installAction = new QAction("Install",this);
    connect(installAction, SIGNAL(triggered()), this, SLOT(install()));
    removeAction = new QAction("Remove",this);
    connect(removeAction, SIGNAL(triggered()), this, SLOT(remove()));
}

void qt4urpmi::contextMenuEvent(QContextMenuEvent *event)
{
    QMenu menu(this);
    menu.addAction(installAction);
    menu.addAction(removeAction);
    menu.exec(event->globalPos());
}

